Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_tvd.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 2024)
@@ -2,5 +2,5 @@
    !!==============================================================================
    !!                       ***  MODULE  traadv_tvd  ***
-   !! Ocean active tracers:  horizontal & vertical advective trend
+   !! Ocean  tracers:  horizontal & vertical advective trend
    !!==============================================================================
    !! History :       !  95-12  (L. Mortier)  Original code
@@ -8,9 +8,10 @@
    !!                 !  00-10  (MA Foujols E.Kestenare)  include file not routine
    !!                 !  00-12  (E. Kestenare M. Levy)  fix bug in trtrd indexes
-   !!                 !  01-07  (E. Durand G. Madec)  adaptation to ORCA config
+   !!                 !  01-07  (E. Durand G. Madec)  adaptraation to ORCA config
    !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
    !!            9.0  !  04-01  (A. de Miranda, G. Madec, J.M. Molines ): advective bbl
    !!            9.0  !  08-04  (S. Cravatte) add the i-, j- & k- trends computation
-   !!            " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!            " "  !  09-11  (V. Garnier) Surface pressure gradient organization
+   !!            3.3  !  10-05 (C. Ethe, G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -24,13 +25,11 @@
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! tracers trends
+   USE trdtra      ! tracers trends
    USE in_out_manager  ! I/O manager
    USE dynspg_oce      ! choice/control of key cpp for surface pressure gradient
-   USE trabbl          ! Advective term of BBL
    USE lib_mpp
    USE lbclnk          ! ocean lateral boundary condition (or mpp link) 
    USE diaptr          ! poleward transport diagnostics
-   USE prtctl          ! Print control
 
 
@@ -39,4 +38,6 @@
 
    PUBLIC   tra_adv_tvd    ! routine called by step.F90
+
+   LOGICAL  :: l_trd       ! flag to compute trends
 
    !! * Substitutions
@@ -51,5 +52,6 @@
 CONTAINS
 
-   SUBROUTINE tra_adv_tvd( kt, pun, pvn, pwn )
+   SUBROUTINE tra_adv_tvd ( kt   , cdtype, pun  , pvn, pwn, &
+      &                     ptrab, ptran , ptraa, kjpt   )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_adv_tvd  ***
@@ -62,29 +64,28 @@
       !!       note: - this advection scheme needs a leap-frog time scheme
       !!
-      !! ** Action : - update (ta,sa) with the now advective tracer trends
-      !!             - save the trends in (ztrdt,ztrds) ('key_trdtra')
-      !!----------------------------------------------------------------------
-      USE oce              , ztrdt => ua   ! use ua as workspace
-      USE oce              , ztrds => va   ! use va as workspace
-      !!
-      INTEGER , INTENT(in)                         ::   kt    ! ocean time-step index
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pun   ! ocean velocity u-component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pvn   ! ocean velocity v-component
-      REAL(wp), INTENT(in), DIMENSION(jpi,jpj,jpk) ::   pwn   ! ocean velocity w-component
-      !!
-      INTEGER  ::   ji, jj, jk              ! dummy loop indices
-      REAL(wp) ::                        &  ! temporary scalar
-         ztat, zsat,                     &  !    "         "   
-         z_hdivn_x, z_hdivn_y, z_hdivn
+      !! ** Action : - update (ptraa) with the now advective tracer trends
+      !!             - save the trends 
+      !!----------------------------------------------------------------------
+      !!* Module used
+      USE oce         , zwx => ua   ! use ua as workspace
+      USE oce         , zwy => va   ! use va as workspace
+      !!* Arguments
+      INTEGER         , INTENT(in   )                               ::   kt              ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                               ::   cdtype          ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                               ::   kjpt            ! number of tracers
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk)       ::   pun, pvn, pwn   ! 3 ocean velocity components
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptrab, ptran        ! before and now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::   ptraa           ! tracer trend 
+      !!* Local declarations
+      INTEGER  ::   ji, jj, jk, jn          ! dummy loop indices  
       REAL(wp) ::   &
-         z2dtt, zbtr, zeu, zev,          &  ! temporary scalar
-         zew, z2, zbtr1,                 &  ! temporary scalar
-         zfp_ui, zfp_vj, zfp_wk,         &  !    "         "
-         zfm_ui, zfm_vj, zfm_wk             !    "         "
-      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zti, ztu, ztv, ztw   ! temporary workspace
-      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zsi, zsu, zsv, zsw   !    "           "
-      !!----------------------------------------------------------------------
-
-      zti(:,:,:) = 0.e0   ;   zsi(:,:,:) = 0.e0
+         z2, z2dtt, zbtr, ztra,              &  ! temporary scalar
+         zfp_ui, zfp_vj, zfp_wk,             &  !    "         "
+         zfm_ui, zfm_vj, zfm_wk                 !    "         "
+      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zwi, zwz   ! temporary workspace
+      REAL(wp), DIMENSION (:,:,:), ALLOCATABLE :: ztrdx, ztrdy, ztrdz
+      !!----------------------------------------------------------------------
+
+      zwi(:,:,:) = 0.e0
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -92,286 +93,161 @@
          WRITE(numout,*) 'tra_adv_tvd : TVD advection scheme'
          WRITE(numout,*) '~~~~~~~~~~~'
+         !
+         l_trd = .FALSE.
+         IF( ( cdtype == 'TRA' .AND. l_trdtra ) .OR. ( cdtype == 'TRC' .AND. l_trdtrc ) ) l_trd = .TRUE.
       ENDIF
-
+      !
+      IF( l_trd )  THEN
+        ALLOCATE( ztrdx(jpi,jpj,jpk) )      ;      ztrdx(:,:,:) = 0.
+        ALLOCATE( ztrdy(jpi,jpj,jpk) )      ;      ztrdy(:,:,:) = 0.
+        ALLOCATE( ztrdz(jpi,jpj,jpk) )      ;      ztrdz(:,:,:) = 0.
+      END IF
+      !
       IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.
       ELSE                                        ;    z2 = 2.
       ENDIF
-
-      ! 1. Bottom value : flux set to zero
-      ! ---------------
-      ztu(:,:,jpk) = 0.e0   ;   zsu(:,:,jpk) = 0.e0
-      ztv(:,:,jpk) = 0.e0   ;   zsv(:,:,jpk) = 0.e0
-      ztw(:,:,jpk) = 0.e0   ;   zsw(:,:,jpk) = 0.e0
-      zti(:,:,jpk) = 0.e0   ;   zsi(:,:,jpk) = 0.e0
-
-
-      ! 2. upstream advection with initial mass fluxes & intermediate update
-      ! --------------------------------------------------------------------
-      ! upstream tracer flux in the i and j direction
-      DO jk = 1, jpkm1
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               zeu = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zev = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-               ! upstream scheme
-               zfp_ui = zeu + ABS( zeu )
-               zfm_ui = zeu - ABS( zeu )
-               zfp_vj = zev + ABS( zev )
-               zfm_vj = zev - ABS( zev )
-               ztu(ji,jj,jk) = zfp_ui * tb(ji,jj,jk) + zfm_ui * tb(ji+1,jj  ,jk)
-               ztv(ji,jj,jk) = zfp_vj * tb(ji,jj,jk) + zfm_vj * tb(ji  ,jj+1,jk)
-               zsu(ji,jj,jk) = zfp_ui * sb(ji,jj,jk) + zfm_ui * sb(ji+1,jj  ,jk)
-               zsv(ji,jj,jk) = zfp_vj * sb(ji,jj,jk) + zfm_vj * sb(ji  ,jj+1,jk)
-            END DO
-         END DO
-      END DO
-
-      ! upstream tracer flux in the k direction
-      ! Surface value
-      IF( lk_vvl ) THEN
-         ! variable volume : flux set to zero
-         ztw(:,:,1) = 0.e0
-         zsw(:,:,1) = 0.e0
-      ELSE
-         ! free surface-constant volume
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zew = e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,1)
-               ztw(ji,jj,1) = zew * tb(ji,jj,1)
-               zsw(ji,jj,1) = zew * sb(ji,jj,1)
-            END DO
-         END DO
-      ENDIF
-
-      ! Interior value
-      DO jk = 2, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zew = 0.5 * e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,jk)
-               zfp_wk = zew + ABS( zew )
-               zfm_wk = zew - ABS( zew )
-               ztw(ji,jj,jk) = zfp_wk * tb(ji,jj,jk) + zfm_wk * tb(ji,jj,jk-1)
-               zsw(ji,jj,jk) = zfp_wk * sb(ji,jj,jk) + zfm_wk * sb(ji,jj,jk-1)
-            END DO
-         END DO
-      END DO
-
-      ! total advective trend
-      DO jk = 1, jpkm1
-         z2dtt = z2 * rdttra(jk)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zbtr = 1./ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-               ! total intermediate advective trends
-               ztat = - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  )   &
-                  &     + ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  )   &
-                  &     + ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1) ) * zbtr
-               zsat = - ( zsu(ji,jj,jk) - zsu(ji-1,jj  ,jk  )   & 
-                  &     + zsv(ji,jj,jk) - zsv(ji  ,jj-1,jk  )   &
-                  &     + zsw(ji,jj,jk) - zsw(ji  ,jj  ,jk+1) ) * zbtr
-               ! update and guess with monotonic sheme
-               ta(ji,jj,jk) =  ta(ji,jj,jk) + ztat
-               sa(ji,jj,jk) =  sa(ji,jj,jk) + zsat
-               zti (ji,jj,jk) = ( tb(ji,jj,jk) + z2dtt * ztat ) * tmask(ji,jj,jk)
-               zsi (ji,jj,jk) = ( sb(ji,jj,jk) + z2dtt * zsat ) * tmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! "zonal" mean advective heat and salt transport
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         pht_adv(:) = ptr_vj( ztv(:,:,:) )
-         pst_adv(:) = ptr_vj( zsv(:,:,:) )
-      ENDIF
-
-      ! Save the intermediate i / j / k advective trends for diagnostics
-      ! -------------------------------------------------------------------
-      ! Warning : We should use zun instead of un in the computations below, but we
-      ! also use hdivn which is computed with un, vn (check ???). So we use un, vn
-      ! for consistency. Results are therefore approximate with key_trabbl_adv.
-
-      IF( l_trdtra ) THEN
-         ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
-         ! 
-         ! T/S ZONAL advection trends
+      !
+      !                                                          ! ===========
+      DO jn = 1, kjpt                                            ! tracer loop
+         !                                                       ! ===========
+         ! 1. Bottom value : flux set to zero
+         ! ----------------------------------
+         zwx(:,:,jpk) = 0.e0    ;    zwz(:,:,jpk) = 0.e0
+         zwy(:,:,jpk) = 0.e0    ;    zwi(:,:,jpk) = 0.e0
+
+         ! 2. upstream advection with initial mass fluxes & intermediate update
+         ! --------------------------------------------------------------------
+         ! upstream tracer flux in the i and j direction
          DO jk = 1, jpkm1
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  ! upstream scheme
+                  zfp_ui = pun(ji,jj,jk) + ABS( pun(ji,jj,jk) )
+                  zfm_ui = pun(ji,jj,jk) - ABS( pun(ji,jj,jk) )
+                  zfp_vj = pvn(ji,jj,jk) + ABS( pvn(ji,jj,jk) )
+                  zfm_vj = pvn(ji,jj,jk) - ABS( pvn(ji,jj,jk) )
+                  zwx(ji,jj,jk) = 0.5 * ( zfp_ui * ptrab(ji,jj,jk,jn) + zfm_ui * ptrab(ji+1,jj  ,jk,jn) )
+                  zwy(ji,jj,jk) = 0.5 * ( zfp_vj * ptrab(ji,jj,jk,jn) + zfm_vj * ptrab(ji  ,jj+1,jk,jn) )
+               END DO
+            END DO
+         END DO
+
+         ! upstream tracer flux in the k direction
+         ! Surface value
+         IF( lk_vvl ) THEN   ;   zwz(:,:, 1 ) = 0.e0                         ! volume variable
+         ELSE                ;   zwz(:,:, 1 ) = pwn(:,:,1) * ptrab(:,:,1,jn)   ! linear free surface 
+         ENDIF
+         ! Interior value
+         DO jk = 2, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zfp_wk = pwn(ji,jj,jk) + ABS( pwn(ji,jj,jk) )
+                  zfm_wk = pwn(ji,jj,jk) - ABS( pwn(ji,jj,jk) )
+                  zwz(ji,jj,jk) = 0.5 * ( zfp_wk * ptrab(ji,jj,jk,jn) + zfm_wk * ptrab(ji,jj,jk-1,jn) )
+               END DO
+            END DO
+         END DO
+
+         ! total advective trend
+         DO jk = 1, jpkm1
+            z2dtt = z2 * rdttra(jk)
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  ztrdt(ji,jj,jk) = - ( ztu(ji,jj,jk) - ztu(ji-1,jj,jk) ) * zbtr
-                  ztrds(ji,jj,jk) = - ( zsu(ji,jj,jk) - zsu(ji-1,jj,jk) ) * zbtr
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt)    ! save the trends
-         !
-         ! T/S MERIDIONAL advection trends
+                  ! total intermediate advective trends
+                  ztra = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                     &             + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  )   &
+                     &             + zwz(ji,jj,jk) - zwz(ji  ,jj  ,jk+1) )
+                  ! update and guess with monotonic sheme
+                  ptraa(ji,jj,jk,jn) =   ptraa(ji,jj,jk,jn)         + ztra
+                  zwi(ji,jj,jk)    = ( ptrab(ji,jj,jk,jn) + z2dtt * ztra ) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+         !                             ! Lateral boundary conditions on zwi  (unchanged sign)
+         CALL lbc_lnk( zwi, 'T', 1. )  
+
+         !                                 ! trend diagnostics (contribution of upstream fluxes)
+         IF( l_trd )  THEN 
+            ! store intermediate advective trends
+            ztrdx(:,:,:) = zwx(:,:,:)   ;    ztrdy(:,:,:) = zwy(:,:,:)  ;   ztrdz(:,:,:) = zwz(:,:,:)
+         END IF
+         !                                 ! "Poleward" heat and salt transports (contribution of upstream fluxes)
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN  
+           IF( jn == jp_tem )  pht_adv(:) = ptr_vj( zwy(:,:,:) )
+           IF( jn == jp_sal )  pst_adv(:) = ptr_vj( zwy(:,:,:) )
+         ENDIF
+
+         ! 3. antidiffusive flux : high order minus low order
+         ! --------------------------------------------------
+         ! antidiffusive flux on i and j
+         DO jk = 1, jpkm1
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  zwx(ji,jj,jk) = 0.5 * pun(ji,jj,jk) * ( ptran(ji,jj,jk,jn) + ptran(ji+1,jj,jk,jn) ) - zwx(ji,jj,jk)
+                  zwy(ji,jj,jk) = 0.5 * pvn(ji,jj,jk) * ( ptran(ji,jj,jk,jn) + ptran(ji,jj+1,jk,jn) ) - zwy(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+      
+         ! antidiffusive flux on k
+         ! Surface value
+         zwz(:,:,1) = 0.e0
+         ! Interior value
+         DO jk = 2, jpkm1
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zwz(ji,jj,jk) = 0.5 * pwn(ji,jj,jk) * ( ptran(ji,jj,jk,jn) + ptran(ji,jj,jk-1,jn) ) - zwz(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+
+         ! Lateral bondary conditions
+         CALL lbc_lnk( zwx, 'U', -1. )
+         CALL lbc_lnk( zwy, 'V', -1. )
+         CALL lbc_lnk( zwz, 'W',  1. )
+
+         ! 4. monotonicity algorithm
+         ! -------------------------
+         CALL nonosc( ptrab(:,:,:,jn), zwx, zwy, zwz, zwi, z2 )
+
+
+         ! 5. final trend with corrected fluxes
+         ! ------------------------------------
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zbtr      = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  ztrdt(ji,jj,jk) = - ( ztv(ji,jj,jk) - ztv(ji,jj-1,jk) ) * zbtr
-                  ztrds(ji,jj,jk) = - ( zsv(ji,jj,jk) - zsv(ji,jj-1,jk) ) * zbtr
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt)     ! save the trends
+               DO ji = fs_2, fs_jpim1   ! vector opt.  
+                  zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ! total advective trends
+                  ztra = - zbtr * (  zwx(ji,jj,jk) - zwx(ji-1,jj  ,jk  )   &
+                     &             + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  )   &
+                     &             + zwz(ji,jj,jk) - zwz(ji  ,jj  ,jk+1) )
+                  ! add them to the general tracer trends
+                  ptraa(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn) + ztra
+               END DO
+            END DO
+         END DO
+
+         !                                 ! trend diagnostics (contribution of upstream fluxes)
+         IF( l_trd )  THEN 
+            ztrdx(:,:,:) = ztrdx(:,:,:) + zwx(:,:,:)  ! <<< Add to previously computed
+            ztrdy(:,:,:) = ztrdy(:,:,:) + zwy(:,:,:)  ! <<< Add to previously computed
+            ztrdz(:,:,:) = ztrdz(:,:,:) + zwz(:,:,:)  ! <<< Add to previously computed
+            
+            CALL trd_tra( kt, cdtype, jn, jptra_trd_xad, ztrdx, pun, ptran(:,:,:,jn) )   
+            CALL trd_tra( kt, cdtype, jn, jptra_trd_yad, ztrdy, pvn, ptran(:,:,:,jn) )  
+            CALL trd_tra( kt, cdtype, jn, jptra_trd_zad, ztrdz, pwn, ptran(:,:,:,jn) ) 
+         END IF
+         !                                 ! "Poleward" heat and salt transports (contribution of upstream fluxes)
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN  
+           IF( jn == jp_tem )  pht_adv(:) = ptr_vj( zwy(:,:,:) ) + pht_adv(:)
+           IF( jn == jp_sal )  pst_adv(:) = ptr_vj( zwy(:,:,:) ) + pst_adv(:)
+         ENDIF
          !
-         ! T/S VERTICAL advection trends
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.         
-                  zbtr      = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  ztrdt(ji,jj,jk) = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr
-                  ztrds(ji,jj,jk) = - ( zsw(ji,jj,jk) - zsw(ji,jj,jk+1) ) * zbtr
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt)     ! save the trends
-         !
-      ENDIF
-
-      ! Lateral boundary conditions on zti, zsi   (unchanged sign)
-      CALL lbc_lnk( zti, 'T', 1. )
-      CALL lbc_lnk( zsi, 'T', 1. )
-
-
-      ! 3. antidiffusive flux : high order minus low order
-      ! --------------------------------------------------
-      ! antidiffusive flux on i and j
-      DO jk = 1, jpkm1
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               zeu = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zev = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-               ztu(ji,jj,jk) = zeu * ( tn(ji,jj,jk) + tn(ji+1,jj,jk) ) - ztu(ji,jj,jk)
-               zsu(ji,jj,jk) = zeu * ( sn(ji,jj,jk) + sn(ji+1,jj,jk) ) - zsu(ji,jj,jk)
-               ztv(ji,jj,jk) = zev * ( tn(ji,jj,jk) + tn(ji,jj+1,jk) ) - ztv(ji,jj,jk)
-               zsv(ji,jj,jk) = zev * ( sn(ji,jj,jk) + sn(ji,jj+1,jk) ) - zsv(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-      
-      ! antidiffusive flux on k
-      ! Surface value
-      ztw(:,:,1) = 0.e0
-      zsw(:,:,1) = 0.e0
-
-      ! Interior value
-      DO jk = 2, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zew = 0.5 * e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,jk)
-               ztw(ji,jj,jk) = zew * ( tn(ji,jj,jk) + tn(ji,jj,jk-1) ) - ztw(ji,jj,jk)
-               zsw(ji,jj,jk) = zew * ( sn(ji,jj,jk) + sn(ji,jj,jk-1) ) - zsw(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! Lateral bondary conditions
-      CALL lbc_lnk( ztu, 'U', -1. )   ;   CALL lbc_lnk( zsu, 'U', -1. )
-      CALL lbc_lnk( ztv, 'V', -1. )   ;   CALL lbc_lnk( zsv, 'V', -1. )
-      CALL lbc_lnk( ztw, 'W',  1. )   ;   CALL lbc_lnk( zsw, 'W',  1. )
-
-      ! 4. monotonicity algorithm
-      ! -------------------------
-      CALL nonosc( tb, ztu, ztv, ztw, zti, z2 )
-      CALL nonosc( sb, zsu, zsv, zsw, zsi, z2 )
-
-
-      ! 5. final trend with corrected fluxes
-      ! ------------------------------------
-      DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.  
-               zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-               ! total advective trends
-               ztat = - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  )   &
-                  &     + ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  )   &
-                  &     + ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1) ) * zbtr
-               zsat = - ( zsu(ji,jj,jk) - zsu(ji-1,jj  ,jk  )   &
-                  &     + zsv(ji,jj,jk) - zsv(ji  ,jj-1,jk  )   &
-                  &     + zsw(ji,jj,jk) - zsw(ji  ,jj  ,jk+1) ) * zbtr
-               ! add them to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + ztat
-               sa(ji,jj,jk) = sa(ji,jj,jk) + zsat
-            END DO
-         END DO
-      END DO
-
-
-      ! Save the advective trends for diagnostics
-      ! --------------------------------------------
-
-      IF( l_trdtra ) THEN
-         ztrdt(:,:,:) = 0.e0   ;   ztrds(:,:,:) = 0.e0
-         !
-         ! T/S ZONAL advection trends
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  !-- Compute zonal divergence by splitting hdivn (see divcur.F90)
-                  !   N.B. This computation is not valid along OBCs (if any)
-                  zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  z_hdivn_x = (  e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * pun(ji  ,jj,jk)          &
-                     &         - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * pun(ji-1,jj,jk) ) * zbtr
-                  !-- Compute T/S zonal advection trends
-                  ztrdt(ji,jj,jk) = - ( ztu(ji,jj,jk) - ztu(ji-1,jj,jk) ) * zbtr + tn(ji,jj,jk) * z_hdivn_x
-                  ztrds(ji,jj,jk) = - ( zsu(ji,jj,jk) - zsu(ji-1,jj,jk) ) * zbtr + sn(ji,jj,jk) * z_hdivn_x
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_xad, 'TRA', kt, cnbpas='bis')   ! <<< ADD TO PREVIOUSLY COMPUTED
-         !
-         ! T/S MERIDIONAL advection trends
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  !-- Compute merid. divergence by splitting hdivn (see divcur.F90)
-                  !   N.B. This computation is not valid along OBCs (if any)
-                  zbtr      = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-                  z_hdivn_y = (  e1v(ji,  jj) * fse3v(ji,jj  ,jk) * pvn(ji,jj  ,jk)          &
-                     &         - e1v(ji,jj-1) * fse3v(ji,jj-1,jk) * pvn(ji,jj-1,jk) ) * zbtr
-                  !-- Compute T/S meridional advection trends
-                  ztrdt(ji,jj,jk) = - ( ztv(ji,jj,jk) - ztv(ji,jj-1,jk) ) * zbtr + tn(ji,jj,jk) * z_hdivn_y          
-                  ztrds(ji,jj,jk) = - ( zsv(ji,jj,jk) - zsv(ji,jj-1,jk) ) * zbtr + sn(ji,jj,jk) * z_hdivn_y          
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_yad, 'TRA', kt, cnbpas='bis')   ! <<< ADD TO PREVIOUSLY COMPUTED
-         !
-         ! T/S VERTICAL advection trends
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  zbtr1     = 1. / ( e1t(ji,jj) * e2t(ji,jj) )
-#if defined key_zco
-                  zbtr      = zbtr1
-                  z_hdivn_x = e2u(ji,jj)*pun(ji,jj,jk) - e2u(ji-1,jj)*pun(ji-1,jj,jk)
-                  z_hdivn_y = e1v(ji,jj)*pvn(ji,jj,jk) - e1v(ji,jj-1)*pvn(ji,jj-1,jk)
-#else
-                  zbtr      = zbtr1 / fse3t(ji,jj,jk)
-                  z_hdivn_x = e2u(ji,jj)*fse3u(ji,jj,jk)*pun(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk)*pun(ji-1,jj,jk)
-                  z_hdivn_y = e1v(ji,jj)*fse3v(ji,jj,jk)*pvn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk)*pvn(ji,jj-1,jk)
-#endif
-                  z_hdivn   = (z_hdivn_x + z_hdivn_y) * zbtr
-                  zbtr      = zbtr1 / fse3t(ji,jj,jk)
-                  ztrdt(ji,jj,jk) = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr - tn(ji,jj,jk) * z_hdivn
-                  ztrds(ji,jj,jk) = - ( zsw(ji,jj,jk) - zsw(ji,jj,jk+1) ) * zbtr - sn(ji,jj,jk) * z_hdivn
-               END DO
-            END DO
-         END DO
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_zad, 'TRA', kt, cnbpas='bis')   ! <<< ADD TO PREVIOUSLY COMPUTED
-         !
-      ENDIF
-
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' tvd adv  - Ta: ', mask1=tmask,   &
-         &                       tab3d_2=sa, clinfo2=           ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-      ! "zonal" mean advective heat and salt transport
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         pht_adv(:) = ptr_vj( ztv(:,:,:) ) + pht_adv(:)
-         pst_adv(:) = ptr_vj( zsv(:,:,:) ) + pst_adv(:)
-      ENDIF
+      ENDDO
+      !
+      IF( l_trd )  THEN
+        DEALLOCATE( ztrdx )     ;     DEALLOCATE( ztrdy )     ;      DEALLOCATE( ztrdz )  
+      END IF
       !
    END SUBROUTINE tra_adv_tvd
@@ -392,7 +268,8 @@
       !!----------------------------------------------------------------------
       REAL(wp), INTENT( in ) ::   prdt   ! ???
+      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT( in    ) ::   &
+         pbef,                            & ! before field
+         paft                               ! after field
       REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT( inout ) ::   &
-         pbef,                            & ! before field
-         paft,                            & ! after field
          paa,                             & ! monotonic flux in the i direction
          pbb,                             & ! monotonic flux in the j direction
